 import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.*;
import com.nokia.mid.ui.FullCanvas;
import java.lang.*;



class TestCanvas
    extends FullCanvas
    implements Runnable, CommandListener
{
    private static final int MILLIS_PER_TICK = 100;

private static final String Titles[]={
  "Riders on the storm",
  "Co za czasy",
  "Juz nie zapomnisz mnie",
  "Ale to juz bylo",
  "Beata",
  "Bo jo cie kochom",
  "Czterej pancerni i pies",
  "Gdybym mial gitare",
  "Goralu, czy ci nie zal?",
  "Hej bystra woda",
  "Jada wozy kolorowe",
  "Komu dzwonia, temu dzwonia",
  "Krajka",
  "Lwow",
  "Malgoska",
  "My cyganie",
  "Najwiecej witaminy",
  "Nie placz, kiedy odjade",
  "Pamietasz, byla jesien",
  "Piesn pozegnalna",
  "Stokrotka",
  "Szla dzieweczka",
  "Ukraina",
  "A wszystko to",
  "Agnieszka",
  "Autobiografia Jolki, Jolki",
  "Orla cien",
  "Zabij sie",
  "IV L.O.",
  "Chlopaki nie placza",
  "Dzieci",
  "I love you",
  "Jestem z miasta",
  "King",
  "Wielka milosc do babci klozetowej",
  "Koniec",
  "Makumba ska",
  "Nie pij Piotrek",
  "Ona jest pedalem",
  "Przewrocilo sie",
  "Ballada o smutnym skinie",
  "Wlosy",
  "Wszystko chuj",
  "Wychowanie",
  "Wytraclas",
  "Lza dla cieniow minionych",
  "Arahia",
  "Ballada o dwoch siotrach",
  "Baranek",
  "Celina",
  "Dolina",
  "Gdy nie ma dzieci",
  "Dom wschodzacego slonca",
  "Inzynierowie z petrobudowy",
  "Knajpa mordercow",
  "Kurwy wedrowniczki",
  "Lewe lewe loff",
  "Panie waldku, pan sie nie boi",
  "Pasazer",
  "Polska",
  "Smierc poety",
  "Tata dilera/Hardzone",
  "Anna Maria",
  "Chodz, pomaluj moj swiat",
  "Ciagle pada",
  "Dozwolone od lat 18",
  "Gdy kiedys znow zawolam cie",
  "Historia jednej znajomosci",
  "Isc w strone slonca",
  "Kwiaty we wlosach",
  "Ludzkie gadanie",
  "Matura",
  "Nie zadzieraj nosa",
  "Niech zyje bal",
  "Tak bardzo sie staralem",
  "Takie ladne oczy",
  "Uciekaj moje serce",
  "A my nie chcemy",
  "Co sie stalo z nasza klasa",
  "Mury",
  "Naprawde nie dzieje sie nic",
  "Oblawa",
  "Sen Katarzyny II",
  "Zeby Polska byla Polska",
  "Babe zeslal bog",
  "Czerwony jak cegla",
  "Dlugosc dzwieku samotnosci",
  "Jedwab",
  "Kochac inaczej",
  "Leze",
  "Marchewkowe pole",
  "Maryna",
  "Mniej niz zero",
  "Nie stalo sie nic",
  "Niekoniecznie o mezczyznie",
  "O Peggy Brown",
  "Och,Ela",
  "Potrzebuje wczoraj",
  "Sowa",
  "W domach z betonu",
  "ZCHN zbliza sie",
  "Zoska",
  "Piosenka dla Wojtka Bellona",
  "Ach, kiedy znowu rusza dla mnie dni?",
  "Bedziesz moja pania",
  "Beskid",
  "Czarny blues o czwartej nad ranem",
  "Dni ktorych nie znamy",
  "Gloria",
  "Jak",
  "Jest juz za pozno, nie jest za pozno",
  "Kim wlasciwie byla ta piekna pani...",
  "Kochaj mnie i dotykaj",
  "Koncert",
  "Majster Bieda",
  "Nie brooklinski most",
  "Nie rozdziobia nas kruki",
  "Opadly mgly, wstaje nowy dzien",
  "Piosenka retro",
  "Specjalista od wzruszen",
  "Wedrowka zycie jest czlowieka",
  "Z nim bedziesz szczesliwsza",
  "Tobie albo zawieja w Michigan",
  "Dziesiec przykazan",
  "Beniamin",
  "Dreams",
  "HO",
  "Kolysanka dla nieznajomej",
  "Kto moze to dac",
  "Lato",
  "List",
  "Na sen",
  "Nadzieja",
  "Nie pytaj mnie co jest dobre a co zle",
  "Niecierpliwi",
  "Ostatni",
  "Piosenka ksiezycowa",
  "Przez ile drog",
  "Son of the blue sky",
  "Sowa",
  "Szczesliwej drogi juz czas",
  "Obudz we mnie swoja Venus",
  "Wyznanie",
  "Zanim zrozumiesz",
  "Autsajder",
  "Corka rybaka",
  "Kocham Cie jak Irlandie",
  "Jolka, jolka...",
  "Nie moge ci wiele dac",
  "Nie placz, Ewka",
  "Oprocz",
  "Przezyj to sam",
  "Sen o Warszawie",
  "Skora",
  "Spiewac kazdy moze",
  "Teksanski",
  "Tolerancja",
  "Wehikul czasu",
  "Whisky",
  "Zawsze tam gdzie ty",
  "Zazdrosc",
  "Zegarmistrz swiatla",
  "Amsterdam",
  "Bar w Beskidzie",
  "24 lutego (Bijatyka)",
  "Czarna chmura",
  "Cztery piwka",
  "Dziesiec w skali Beuforta",
  "Dziki wloczega",
  "Emeryt",
  "Gdzie ta keja",
  "Green horn",
  "Heave away Santiana",
  "Hej, zeglujze zeglarzu",
  "Hiszpanskie dziewczyny",
  "John Kanaka",
  "Marco Polo",
  "Mewy",
  "Mona",
  "Piwo",
  "Przechyly",
  "Szesnascie ton",
  "Tancowanie",
  "Bez aluzji",
  "Duzo pale",
""}; 
 
    private String Chords,Txt;  
    private int SChords=-1,STxt=-1;
    
    private final int SongCount= 185 ; 


    private Image        image, panel_image, init_image;
    private Font         font1, font2;

    private final String Alphabet=" 2ABCDEGHIJKLMNOPRSTUWZ";
    private final int    AlphabetCount= 22 ; 
    private       int    AlphabetPos= 1 ; 


    char CL=' ';
    int  YPos=0, XPos=0;    
    int  mode=-1;
    int  selection=-1;

    TestCanvas()
    {
    }

    private void listwr(Graphics g)
    {
	int i, j, k=YPos;
	String l;

	g.setFont(font2);
	g.setColor(200,200,255);
	g.fillRect(0,0,128,20);
	g.setColor(255,255,255);
	g.fillRect(0,21,127,127);
	g.setColor(255,0,0);
	l=String.valueOf(CL);
	g.drawString( l, 3,1, (Graphics.TOP | Graphics.LEFT));
	if (CL==' ') {
  	    g.drawString( "Spis piosenek", 3,1, (Graphics.TOP | Graphics.LEFT));
	}
	g.setFont(font1);
	g.setColor(0,0,0);

        for( i=j=0; i<SongCount; i++) {

	    if ((CL==' ') || (CL==Titles[i].charAt(0))) {
		if (k-->0) continue;
	        if (j==0) {
		    g.setColor(128,128,255);
		    g.fillRect(0,20,128,10);
		    g.setColor(0,0,0);
		    selection=i;
		}
                g.drawString( Titles[i], 1, 22+j*8, (Graphics.TOP | Graphics.LEFT));
		if (j++>10) break;
	    }
	}
	if ((j==0)&&(YPos>0)) {
	    YPos=YPos-k-1;
	    listwr(g);
	}
    }

    private void bckground(Graphics g)
    {
   	    g.drawImage( panel_image, 0 , 0, Graphics.TOP | Graphics.LEFT);
	    g.setColor(255,255,255);
	    g.fillRect(1,21,126,105);
   	    g.drawImage( image, 77 , 32, Graphics.TOP | Graphics.LEFT);
	    g.setFont(font2);
       	    g.drawString( Titles[selection], 3-XPos, 2, (Graphics.TOP | Graphics.LEFT));
	    g.setFont(font1);
	    g.setColor(0,0,0);
	    g.drawRect(0,20,127,107);
    }

    private void chordwr(Graphics g)
    {
	int i, j, k=0;
        String l="";

  	if (selection!=-1) {
	    if (selection!=SChords) {
	        Chords=my_get_text( selection, "chr.txt" );	
		SChords=selection;
	    }
	    bckground(g);
	    k=-YPos;
	    for(i=j=0;i<Chords.length(); i++) {
	        if ((Chords.charAt(i)=='|')||(i==Chords.length()-1)) {
	  	    if (k++<=0) { j=i+1; continue;}
                    l=Chords.substring( j, i);
	  	    j=i+1;
	       	    g.drawString( l, 3-XPos, 10+8*k, (Graphics.TOP | Graphics.LEFT));
	        }
	    }
	}
	if ((k<0)&&(YPos>0)) {
	    YPos+=k;
	    chordwr(g);
	}
    }

    private void textwr(Graphics g)
    {
	int i, j, k=0;
        String l="";

  	if (selection!=-1) {
	    if (selection!=STxt) {
	    	Txt=my_get_text( selection, "txt.txt" );	
		STxt=selection;
	    }
	    bckground(g);
	    k=-YPos;
	    for(i=j=0;i<Txt.length(); i++) {
	        if ((Txt.charAt(i)=='|')||(i==Txt.length()-1)) {
	  	    if (++k<=0) { j=i+1; continue;}	    
                    l=Txt.substring( j, i);
	  	    j=i+1;
		    if (l.length()==1) {
			g.setColor(180,0,0);
			if (l.charAt(0)=='R')
			    l="Ref.";
	       	    	g.drawString( l, 3-XPos, 15+8*k, (Graphics.TOP | Graphics.LEFT));
		    } else {
			g.setColor(0,0,0);
	       	    	g.drawString( l, 15-XPos, 15+8*k, (Graphics.TOP | Graphics.LEFT));
		    }
		    if (k>14) break;
	        }
	    }
	}
	if ((k<0)&&(YPos>0)) {
	    YPos+=k;
	    textwr(g);
	}

    }

    private void logowr(Graphics g)
    {
        g.drawImage( init_image, 0 , 0, Graphics.TOP | Graphics.LEFT);
	if (mode==-2) {
	    g.setFont(font2);
	    g.setColor(0,0,0);
	    g.fillRect( 20,35, 88,30);
	    g.setColor(255,255,255);
	    g.drawRect( 20,35, 88,30);
	    g.drawString( "Wczytuje...", 25,40, (Graphics.TOP | Graphics.LEFT));
	    g.setColor(0,0,0);
	}
    }

    public void paint(Graphics g)
    {
	if (mode<0) {
            logowr(g);
	} else if (mode==0) {
            listwr(g);
	} else if (mode==1) {
            chordwr(g);
	} else if (mode==2) {
            textwr(g);
	}
    }       

    public String my_get_text( int nr, String ResName)
    {
        InputStream IStr;
	int i, j=nr;
	byte b[]={0};
	String TTxt;

	IStr= getClass().getResourceAsStream(ResName);
	i=1;
	TTxt="";

	while(i>0) {
	    try {
	        i = IStr.read(b);
	    }
            catch (IOException e)
            {
		break;
            }
	    if (i>0) {
		if (j==0) {
	            TTxt=TTxt.concat( String.valueOf( (char) b[0]) );
		} 
	        if ( (char) b[0] =='\n') {
		    if (--j<0) 
			break;
		    else if ((j>0) && (ResName.charAt(0)=='t')) {
			try { IStr.skip(216);}
	                catch (IOException e) {break;}
		    }
		}
	    }
	}
	return TTxt;
    }

    public synchronized void start()
    {

        font1 = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_SMALL);
        font2 = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_MEDIUM);

        try
        {
            image       = Image.createImage("/guitar.gif");
            panel_image = Image.createImage("/panel.png");
            init_image  = Image.createImage("/init.gif");
	}
        catch (IOException e)
        {
            image = null; /* todo */
        }
    }


    public void run()
    {
    }

    public void keyRepeated(int keyCode)
    {
	keyPressed(keyCode);
	keyPressed(keyCode);
	keyPressed(keyCode);
    }

    public void keyPressed(int keyCode)
    {
//	int k=0;
//	if (mode==0) { mode=1; return; }
	int oldmode=mode;

	if (keyCode=='0') {
	    mode=2; YPos=0;
	} else if (keyCode=='1') {
	    mode=-1;
	} else if ( (keyCode=='5') || (keyCode==-10)) {
	    switch (mode) {
		case 0:  mode=1; break;
		case 1:  mode=0; break;
		case 2:  mode=1; break;
	    }
	    YPos=XPos=0;
        } else if ((keyCode=='8')||(keyCode==-2)) {
            YPos++;
	} else if ((keyCode=='2')||(keyCode==-1)) {
            if (YPos>0) YPos--;
	} else if ((keyCode=='6')||(keyCode==-4)) {
	    if (mode==0) {
	        if (++AlphabetPos>AlphabetCount)
		    AlphabetPos=0;
	        CL=Alphabet.charAt(AlphabetPos);
	    } else if (XPos<120) XPos+=5;
	} else if ((keyCode=='4')||(keyCode==-3)) {
	    if (mode==0) {
	        if (--AlphabetPos<0)
		    AlphabetPos=AlphabetCount-1;
	        CL=Alphabet.charAt(AlphabetPos);
	    } else if (XPos>4) XPos-=5;
	}
	if ((mode==-1)&&(keyCode!='1')) mode=0;

	if (oldmode!=mode) {
	    oldmode=mode;
	    mode=-2; /* loading... */
            repaint(0, 0, getWidth(), getHeight());
 	    serviceRepaints();
	    mode=oldmode;
	}
        repaint(0, 0, getWidth(), getHeight());
    }

    public void commandAction(Command c, Displayable d)
    { }
}